com.ihr.xbrl.om.formula.aspects

## Class CommonAspectRule

- java.lang.Object
- - com.ihr.xbrl.om.formula.aspects.CommonAspectRule

- Direct Known Subclasses:
    ConceptAspectRule, DefaultAspectRule, DimensionCommonAspectRule, EmptyAspectRule, EntityIdentifierAspectRule, FragmentsAspectRule, PeriodAspectRule, UnitAction, UnitAspectRule, UnitNoUnitAspectRule, XPathAspectRule

      public class CommonAspectRule
      extends java.lang.Object

  Helper and common methods in all rules. As, for example, dealing with nearest sources
  Author:
    Ignacio

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `ALLDIMENSIONALASPECTS` The Constant ALLDIMENSIONALASPECTS.
    `static int` | `ALLNONDIMENSIONALASPECTS` The Constant ALLNONDIMENSIONALASPECTS.
    `static int` | `ANY` The Constant ANY.
    `static int` | `COMPLETESCENARIO` The Constant COMPLETESCENARIO.
    `static int` | `COMPLETESEGMENT` The Constant COMPLETESEGMENT.
    `static int` | `CONCEPT` The Constant CONCEPT.
    `static int` | `DIMENSION` The Constant DIMENSION.
    `static int` | `ENTITYIDENTIFIER` The Constant ENTITYIDENTIFIER.
    `static int` | `LOCATION` The Constant LOCATION.
    `static int` | `NONE` The Constant NONE.
    `static int` | `NONXDTSCENARIO` The Constant NONXDTSCENARIO.
    `static int` | `NONXDTSEGMENT` The Constant NONXDTSEGMENT.
    `static int` | `PERIOD` The Constant PERIOD.
    `static int` | `UNIT` The Constant UNIT.
    `static int` | `VALUE` The Constant VALUE.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `CommonAspectRule(net.sf.saxon.s9api.XdmNode aspectNode, XBRLFormula formula)` Instantiates a new common aspect rule.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `static java.lang.String` | `getAspectsText(int aspects)` Converts the bitmap of aspects into a string of comma separated aspect names.

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### NONE

          public static final int NONE

      The Constant NONE.
      See Also:
        Constant Field Values

    - #### LOCATION

          public static final int LOCATION

      The Constant LOCATION.
      See Also:
        Constant Field Values

    - #### CONCEPT

          public static final int CONCEPT

      The Constant CONCEPT.
      See Also:
        Constant Field Values

    - #### ENTITYIDENTIFIER

          public static final int ENTITYIDENTIFIER

      The Constant ENTITYIDENTIFIER.
      See Also:
        Constant Field Values

    - #### PERIOD

          public static final int PERIOD

      The Constant PERIOD.
      See Also:
        Constant Field Values

    - #### UNIT

          public static final int UNIT

      The Constant UNIT.
      See Also:
        Constant Field Values

    - #### COMPLETESEGMENT

          public static final int COMPLETESEGMENT

      The Constant COMPLETESEGMENT.
      See Also:
        Constant Field Values

    - #### COMPLETESCENARIO

          public static final int COMPLETESCENARIO

      The Constant COMPLETESCENARIO.
      See Also:
        Constant Field Values

    - #### NONXDTSEGMENT

          public static final int NONXDTSEGMENT

      The Constant NONXDTSEGMENT.
      See Also:
        Constant Field Values

    - #### NONXDTSCENARIO

          public static final int NONXDTSCENARIO

      The Constant NONXDTSCENARIO.
      See Also:
        Constant Field Values

    - #### DIMENSION

          public static final int DIMENSION

      The Constant DIMENSION.
      See Also:
        Constant Field Values

    - #### VALUE

          public static final int VALUE

      The Constant VALUE.
      See Also:
        Constant Field Values

    - #### ALLDIMENSIONALASPECTS

          public static final int ALLDIMENSIONALASPECTS

      The Constant ALLDIMENSIONALASPECTS.
      See Also:
        Constant Field Values

    - #### ALLNONDIMENSIONALASPECTS

          public static final int ALLNONDIMENSIONALASPECTS

      The Constant ALLNONDIMENSIONALASPECTS.
      See Also:
        Constant Field Values

    - #### ANY

          public static final int ANY

      The Constant ANY.
      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### CommonAspectRule

          public CommonAspectRule(net.sf.saxon.s9api.XdmNode aspectNode,
                          XBRLFormula formula)
                           throws XFxbrlfeIllegalUseOfUncoveredQName

      Instantiates a new common aspect rule.
      Parameters:
        `aspectNode` - the aspect node
        `formula` - the formula
      Throws:
        `XFxbrlfeIllegalUseOfUncoveredQName` - the x fxbrlfe illegal use of uncovered q name

  - ### Method Detail

    - #### getAspectsText

          public static java.lang.String getAspectsText(int aspects)

      Converts the bitmap of aspects into a string of comma separated aspect names. This method is used for logging purposes
      Parameters:
        `aspects` - the aspects
      Returns:
        String